# coding: utf-8

"""
Root Signals API

Root Signals JSON API provides a way to access Root Signals using provisioned API token

The version of the OpenAPI document: 1.0.0 (latest)
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, Field
from typing_extensions import Annotated, Self

from root.generated.openapi_aclient.models.evaluator_execution_function_parameter_property_request import (
    EvaluatorExecutionFunctionParameterPropertyRequest,
)
from root.generated.openapi_aclient.models.evaluator_execution_function_parameter_type_enum import (
    EvaluatorExecutionFunctionParameterTypeEnum,
)


class EvaluatorExecutionFunctionParameterRequest(BaseModel):
    """
    EvaluatorExecutionFunctionParameterRequest
    """  # noqa: E501

    type: EvaluatorExecutionFunctionParameterTypeEnum
    properties: Optional[Dict[str, EvaluatorExecutionFunctionParameterPropertyRequest]] = None
    required: Optional[List[Annotated[str, Field(min_length=1, strict=True)]]] = None
    __properties: ClassVar[List[str]] = ["type", "properties", "required"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of EvaluatorExecutionFunctionParameterRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each value in properties (dict)
        _field_dict = {}
        if self.properties:
            for _key in self.properties:
                if self.properties[_key]:
                    _field_dict[_key] = self.properties[_key].to_dict()
            _dict["properties"] = _field_dict
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of EvaluatorExecutionFunctionParameterRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "type": obj.get("type"),
                "properties": dict(
                    (_k, EvaluatorExecutionFunctionParameterPropertyRequest.from_dict(_v))
                    for _k, _v in obj["properties"].items()
                )
                if obj.get("properties") is not None
                else None,
                "required": obj.get("required"),
            }
        )
        return _obj
